<?php

namespace Lean\Console\Controller;

use League\Route\Router;
use Picea\Caching\Opcache;
use Picea\FileFetcher;
use Picea\Picea;
use Psr\Http\Message\{ ResponseInterface, ServerRequestInterface };

use Notes\Route\Annotation\Object\Route as RouteParam,
    Notes\Route\Annotation\Method\Route,
    Notes\Security\Annotation\Security,
    Notes\Tell\Annotation\Language;

use Lean\Console\{ Form, Lib };

use Picea\Extension\UrlExtension;

use function Home\View\{ _, lang, url, route, form };

/**
 * @Language("lean.caching")
 */
class Caching extends Console {
    use Lib\ConsoleControllerTrait;

    /**
     * @Route("/caching/picea", "name" => "lean.console:caching")
     */
    public function picea(ServerRequestInterface $request, array $arguments) : ResponseInterface
    {
        $list = [];

        if ( isset($this->picea) ) {
            form(new Form\Caching\Picea($this->picea, $list), $this->pushContext(new Lib\FormContext($request, "caching.picea")));
        }

        return $this->renderView("lean-console/page/caching/picea", get_defined_vars());
    }
}