<?php

namespace Lean\Console\Controller;

use League\Route\Router;
use Psr\Http\Message\{ ResponseInterface, ServerRequestInterface };

use Notes\Route\Annotation\Object\Route as RouteParam,
    Notes\Route\Annotation\Method\Route,
    Notes\Security\Annotation\Security,
    Notes\Tell\Annotation\Language;

use \Lean\Console\Lib;

use Picea\Extension\UrlExtension;

/**
 * @Language("lean.request")
 */
class Request extends Console {
    use Lib\ConsoleControllerTrait;

    /**
     * @Route("/request/routes", "name" => "lean.console:request.route")
     * @param ServerRequestInterface $request
     * @param array $arguments
     * @return ResponseInterface
     */
    public function routes(ServerRequestInterface $request, array $arguments) : ResponseInterface
    {
        $routes = $this->container->has(UrlExtension::class) ? $this->container->get(UrlExtension::class)->getRouteList(true) : false;

        uksort($routes, function($a, $b) {
            return $a <=> $b;
        });

        return $this->renderView("lean-console/page/request/route", [
            'routes' => $routes
        ]);
    }
}